      subroutine MiniBUILD(io,ioecho,sNOL,sNOR,sVAR, nLITH,sLITH,
     +   rLITHprop,nWells,sWelNAME,rWelX,rWelY, nWelINT,rWelINT,
     +           rDEFsy,rDEFss,rDEFrHV,sSubMini)
      USE TcompReduceMODULE
      include '..\T-COMP_SUBS-Common\T-COMP_Mini.inc'
      character*1  sDEL
      character*2  sAnnScreen
      character*5  sNOR
      character*5  sNOL
      character*5  sVAR
      CHARACTER*64 sSubMini
      CHARACTER*64 sWelNAME(nMAXwell)
      CHARACTER*64 sLITH(nMAXlith)
      CHARACTER*64 sMMlith(nMAXminiZ)
      CHARACTER*64 sSITE, sSCALE
      CHARACTER(80) files      
      CHARACTER*2048 sTMPfile
      CHARACTER*2048 sTMPtran
      CHARACTER*2048 sTMPpack
      CHARACTER*2048 sTxT
      CHARACTER*2048 sTxT2
      real rRADedge(nMAXminiR)
      real rZedge(nMAXminiZ)
      real rZlith(nMAXminiZ,3)
      real rLITHprop(nMAXlith,4)
      real rWelINT(nMAXint)
      real rn(lrna)
      real rWelX(nMAXwell)
      real rWelY(nMAXwell)
      real rQ 
      real rDT
      real rRADwel
      real rRADann
      real rRADext
      real rCOL
      real rDZmin
      INTEGER iBOUND1D(nMAXminiNODE)
      INTEGER nWelINT(nMAXwell)
      INTEGER nWells
      INTEGER nLITH, iColBOT
      INTEGER iCOL
      INTEGER ierr
      INTEGER ierr1
      INTEGER io
      INTEGER i
      INTEGER ki
      INTEGER ke
      LOGICAL(4) bYN
c
      sDEL = '\'  
      bYN = MAKEDIRQQ(sSubMini)
c  Loop through aquifer test files to be compared 
c   Build Mini MODFLOW models from templates 
      sTxT = trim(sSubMini) //sDel // '01_MFsub_CALL.bat'
      open(io-1, file=sTxT )
      write(io-1,'(a)')'@echo off'
      ierr = 0   
      do while( ierr.ne.-1 .and. ierr.ne.2 )
        call sGET(io,sNOL,sNOR,ierr, 'TemplateFile:',sTMPfile)     !! TemplateFile:TemplateRADIAL\INput_#_Site_#.NAM.txt
        open(io+1, file=sTMPfile, status='OLD', err=10)
        if( ierr.eq.0 )then
c     Echo Basics to HISTORY file           
          call sGET(io,sNOL,sNOR,ierr, 'PumpingWell:',sSITE)       !! PumpingWell:P4      !!      MANDATORY
          write(ioecho,*) 
          write(ioecho,*)'PumpingWell:',sSITE
          rQ = rGET(io, sNOL, sNOR, ierr)                          !! Q-Discharge = 115500      !!  ft3/d   or 600  gpm                !!      MANDATORY
          write(ioecho,*)'  Discharge:',rQ
          call sGET(io,sNOL,sNOR,ierr, 'ScaleHydK:',sSCALE)         !! ScaleHydK:NO          !!      MANDATORY
          call UPCASE(sSCALE)
          bYN = .TRUE.
          if( index(sSCALE,'NO').gt.0 ) bYN = .FALSE.
          if( bYN ) sSCALE = 'YES                              '
          write(ioecho,'(a31,a4)')
     +     '  Scale Hydraulic Conductivity:',trim(sSCALE)
c     
          rDT = rGET(io, sNOL, sNOR, ierr)                         !! Duration = 2.3   days
          rRADwel = rGET(io, sNOL, sNOR, ierr)                     !! WellRadius = 0.5 ft
          rRADann = rGET(io, sNOL, sNOR, ierr)                     !! AnnularRadius = 1.0 ft
          rRADext = rGET(io, sNOL, sNOR, ierr)                     !! RadialExtent = 1500000.  ft   !! Radial extent of supporting  model
          rCOL = rGET(io, sNOL, sNOR, ierr)                        !! Number-of-Columns = 49       
          iCOL = ifrl( rCOL ) 
          write(ioecho,*)'  Pumping period, days:',rDT
          write(ioecho,'(a29,3g12.4)')'  Well, annulus, model radii:', 
     +                  rRADwel, rRADann, rRADext 
          write(ioecho,*)'  Number of columns:',iCOL
c     Echo Basics to HISTORY file           
c       Build edges of mini model in radial direction 
          call RminiDEFINE(iCOL,rRADwel, rRADann, rRADext, rRADedge)
          rDZmin = rGET(io, sNOL, sNOR, ierr)                      !! CellThickness = 5 ft         !! Thickness of cell for vertical discretization  
          rZedge(1) = rGET(io, sNOL, sNOR, ierr)                   !! Depth-to-Water = 54  ft      !! depth to water registers the log with the top of the regional model   
c      Read drillers log and Integrate drillers log with regional model -- breaks and Mean K adjust
          i = iMatchs(sSITE, sWelNAME, nWells)
          call ZminiDEFINE(io,ioecho,sNOL,sNOR, nLITH,sLITH, rLITHprop,
     +        rWelX(i),rWelY(i),nZmini,rDZmin,rZedge,rZlith,sMMlith, 
     +        rDEFsy, rDEFss, rDEFrHV, bYN)
          if( nZmini.gt.0 ) then                    !!         Keep building  
            write(io-1,'(a)')'call 01_Sub_MODFLOW+ '//sSITE                               !! Create master batch file for running all models 
c
c      Create Mini model IBOUND array to simulate completions 
            call IBminiDEFINE(iCOL, nZmini,rZedge, sSITE, nWells,
     +                      sWelNAME,nWelINT,rWelINT, iBOUND1D)
c     Echo site name and specified properties 
          write(ioecho,'(a81,a12)')
     + ' Layer   Top  Screen       Lithology                  ',
     + '      Kx       Storage    Kv-to-Kh       '
c       ----+----1----+----2----+----3----+----4----+----5----+----6
          do i = 1, nzMini
            sAnnScreen = '. '
            if( iBOUND1D((i-1)*iCOL+1).eq.1 ) sAnnScreen(1:1) = '|'
            if( iBOUND1D((i-1)*iCOL+2).eq.1 ) sAnnScreen(2:2) = '='
            write(ioecho,'(i6,f7.0,3x,a2,3x,a32,2x,3g12.4)') 
     +        i,rZedge(i),sAnnScreen, sMMlith(i),(rZlith(i,k),k=1,3)
          end do    
          iBOUND1D((nzMini-1)*iCOL+1) = 1  
c      
c      Clean/create Aquifer-test site directory 
            ki = index(sTMPfile,sDEL)
            i =len(trim(sTMPfile))
            sTxT = sTMPfile(ki:i)
            call sSUBstring(sTxT,sSITE, sVAR, sTxT)                       !!    Correct path in template file
            sTxT = trim(sSubMini) //sDel //trim(sSITE) // sTxT 
            bYN = MAKEDIRQQ(trim(sSubMini) //sDel //trim(sSITE))          !!    Replace placeholder with site name  
c      Create site specific NAME file 
            open(io+2, file=sTxT )                                         !!    OPEN Mini-Model NAME file 
c      Scan through Template NAME file and build each mini model file
            ierr1 = 0   
            do while( ierr1.ne.-1 .and. ierr1.ne.2 )
              ki = len(trim(sTMPtran))
              if( ki.gt.0 ) then
                sTxT = '                    '
                sTMPtran = ''
              else
                call ncread(io+1,sTxT,sNOL,sNOR,ierr1)                 !! 
              endif
              ki = len(trim(sTxT))
              if( ierr1.ne.-1 .and. ierr1.ne.2 .and. ki.gt.0 ) then 
                sTMPpack = sTxT
                ki = index(sTxT,trim(sVAR))
                if( ki.eq.1 ) sTxT(1:len(trim(sVAR))) = 'X'
                if( ki.gt.0 ) call sSUBstring(sTxT,sSITE, sVAR, sTxT)      !!    Replace placeholder with site name  
                if( ki.eq.1 ) sTxT(1:1) = trim(sVAR)
                write(io+2, '(a)') trim(sTxT)      
                sTxT2 = sTxT
                call UPCASE(sTxT2)
                ke = index(sTxT2,' INPUT')
c                if( ki.gt.0 .and. ke.gt.0 ) then                         !!  Test on Replacement and INPUT strings 
                if(  ke.gt.0 ) then                                       !!  Test on INPUT only 
                  ki = index(sTMPfile,sDEL)
                  sTMPpack = sTMPfile(1:ki) // sTMPpack(ke+1:2048)
                  sTxT2 = sDEL // trim(sTxT(ke+1:2048))
                  sTxT2 = trim(sSubMini) //sDel // trim(sSITE) // sTxT2
                  open(io+3, file=sTMPpack, status='OLD', err=10)      !!    OPEN Mini-Model Template file --INPUT
                  open(io+4, file=sTxT2 )                              !!    OPEN Mini-Model local file    --OUTPUT
                  call EchoFiles(io+3,io+4, sDEL,sVAR, sSITE, rQ,rDT, 
     +                         nZmini,rZedge,rZlith, iCOL,rRADedge,
     +                         iBOUND1D,sSubMini)
                  close(io+4)                                          !!   CLOSE Mini-Model local file    --OUTPUT
                  close(io+3)                                          !!   CLOSE Mini-Model Template file --INPUT
                endif  
              endif
            end do         !!  End of inner loop where template name file is scanned 
            close(io+2)     !!   Site specific MODFLOW name file
          else       !!  test in model domain check
            sTxT = ' Mapped extent is outside of model domain:' 
            if( nZmini.lt.0 ) sTxT='  Depth to water deeper than hole:' 
            ki = index(sTxT, ":")
            sTxT = sTxT(1:ki) // sSITE
            write(ioecho,'(a80)') sTxT 
          endif    
          close(io+1)     !!   MODFLOW template file
c          
          call sGET(io,sNOL,sNOR,ierr, 'ListToTransfer:',sTMPtran)     !! TemplateFile:TemplateRADIAL\INput_#_Site_#_DD.mv
          if( len(trim(sTMPtran)).gt.0 .and. nZmini.gt.0 ) then
            open(io+1, file=sTMPtran, status='OLD', err=10)            !!   List of files to transfer file
            ierr2 = 0   
            do while( ierr2.ne.-1 .and. ierr2.ne.2 )
              call ncread(io+1,sTxT,sNOL,sNOR,ierr2)
              if( len(trim(sTxT)).gt.0 .and. sTxT(1:3).ne.'EOF') then
                ki = index(sTxT,':')
                sTxT = sTxT(ki+1:2048)
                ki = index(sTxT,' ')
                sTMPpack = sTxT(1:ki-1)
                ki = index(sTMPfile,sDEL)
                sTxT2 = sTMPfile(1:ki) // sTMPpack
                open(io+3, file=sTxT2, status='OLD', err=10)      !!    OPEN Transfer Template file --INPUT
                ki = index(sTxT,' ')
                sTxT = trim(sTxT(ki+1:2048))
                ki = index(sTMPpack,trim(sVAR))
                if(ki.gt.0)call sSUBstring(sTMPpack,sSITE,sVAR,sTMPpack)      !!    Replace placeholder with site name  
                ki = index(sTxT,trim(sVAR))
                if( ki.gt.0 ) call sSUBstring(sTxT,sSITE, sVAR, sTxT)      !!    Replace placeholder with site name  
                ki = index(sTxT,'PUT:')+4
                if( sTxT(ki:ki).eq.'.' ) ki = ki+1 
                sTxT = trim(sTxT(ki:2048))
                ki = index(sTxT,' ')-1
                if( ki.gt.0 ) then
                  if( sTxT(ki:ki).ne.sDel )then 
                    ki = ki+1
                    sTxT(ki:ki) = sDel
                  endif
                else
                  ki = 1
                  sTxT(ki:ki) = sDel
                endif  
c
                sTxT2 = trim(sSubMini) // trim(sTxT) // trim(sTMPpack)
                open(io+4, file=sTxT2, status='UNKNOWN'  )                              !!    OPEN Transfer local file    --OUTPUT
                call EchoFiles(io+3,io+4, sDEL,sVAR, sSITE, rQ,rDT, 
     +                         nZmini,rZedge,rZlith, iCOL,rRADedge,
     +                         iBOUND1D,sSubMini)
                close(io+4)                                          !!   CLOSE Transfer local file    --OUTPUT
                close(io+3)                                          !!   CLOSE Transfer Template file --INPUT
              else
                ierr2 = -1
              endif
            end do         !!  End of inner loop where transfer file is scanned 
            close(io+1)                                                !!   List of files to transfer file
          endif
        endif  !  end of check that a new aquifer test site exists
      end do !  end of MODFLOW mini model loop 
c
   10 continue
      write(io-1,'(a)')''
c      write(io-1,'(a)')'pause'
      close(io-1)
c  
      return
      end
c ---------------------------------------------------------------------------------
      subroutine ZminiDEFINE(io,ioecho,sNOL,sNOR, nLITH,sLITH,rLITHprop,
     +         xFind, yFind,   nZmini,rDZmin,rZedge,rZlith,sMMlith, 
     +         rDEFsy, rDEFss, rDEFrHV, bSCL )
      USE GLOBAL
      USE TcompReduceMODULE
      include '..\T-COMP_SUBS-Common\T-COMP_Mini.inc'
      character*5   sNOR
      character*5   sNOL
      CHARACTER*64  sLITH(nMAXlith)
      CHARACTER*64  sZElith(nMAXminiZ)
      CHARACTER*64  sMMlith(nMAXminiZ)
      CHARACTER*2048 sTxT, sTx2
      real rDZmin, xFind, yFind
      real rZElith(nMAXminiZ)
      real rZE_KxSySsKv(nMAXminiZ,4)
      real rZedge(nMAXminiZ)
      real rZlith(nMAXminiZ,3)
      real rLITHprop(nMAXlith,4)
      real rn(lrna)
      real rZdiff, rTlith, rTregMOD, rTHKmini
      real rTHKminiSUM, rTHKregSUM 
      real rDEFsy, rDEFss, rDEFrHV
      real rFrac, rVal
      INTEGER nZmini
      INTEGER nLZlith
      INTEGER nLITH
      INTEGER ierr
      INTEGER io
      INTEGER i, ii
      INTEGER j
      INTEGER k, kb
      INTEGER ki
      INTEGER ke
      LOGICAL(4) bSCL
c
c    depth & Lithology  
      i = 0
      do while(i .lt. nMAXminiZ )
        call ncread(io,sTxT,sNOL,sNOR,ierr)
        if( ierr.lt.1 ) then
          i = i + 1 
          call qread(rn,1,sTxT,ierr)
          rZElith(i) = rn(1)
          ki = ifrl(rn(3))
          ke = len(trim(sTxT))
          sTxT = sTxT(ki+1:ke)
          call TrimALL(sTxT)
          call UPCASE(sTxT)
          ki = index(sTxT,' ')
          ke = len(trim(sTxT))
          sTx2 = '' 
          if( ki.lt.ke )then
            sTx2 = sTxT(ki+1:2048)
            sTxT = sTxT(1:ki)
            call TrimALL(sTxT)
          endif
          sZElith(i) = sTxT
c      Test beyond for Sy, Ss and KH2V if present          
          if( len(trim(sTx2)).gt.0 )then
            call qread(rn,4,sTx2,ierr)
            ierr = 4-ierr
            rZE_KxSySsKv(i,1) = rn(1)
            rZE_KxSySsKv(i,2) = rDEFsy
            rZE_KxSySsKv(i,3) = rDEFss
            rZE_KxSySsKv(i,4) = rDEFrHV 
            do ii = 2,4
              if( ii.le.ierr ) rZE_KxSySsKv(i,ii) = rn(i) 
            end do
          else  
            rZE_KxSySsKv(i,1) = -1.
          endif
        else
          nLZlith = i
          i = nMAXminiZ
        endif
      end do !  end of lith table loop 
c
c    Map detailed lithology to minimodel
      nZmini = ( rZElith(nLZlith) - rZedge(1) ) / rDZmin + 1
      rTlith = 0.0
      rTHKminiSUM = 0.0
      do i = 1, nzMini
        if( i.eq.1 ) then 
          rTHKmini = 1.
          iOFF = 0
        else
          rTHKmini = rDZmin
          iOFF = 1
        endif  
        rZedge(i+1) = rZedge(i) + rTHKmini
        ke = iMATCHr((rZedge(i+1)+rZedge(i))/2., rZElith, nLZlith, 1)
        if( ke.gt.0 ) then 
          sMMlith(i) = sZElith(ke)
          ki = iMATCHs(sZElith(ke), sLITH, nLITH)
          if( ki.lt.0 ) sMMlith(i) = 'Undefined--'//sMMlith(i)
          rVal = rZE_KxSySsKv(ke,1)
        else  
          sMMlith(i) = 'Undefined '
          rVal = 1.0
          ke = 1 
        endif  
        if( rVal.le.0.0000 .and. ki.gt.0 ) then  
          rZlith(i,1) = rLITHprop(ki,1)                                    !!  Hydraulic Conductivity is 1 
          rZlith(i,2) = rLITHprop(ki,2+iOFF)                               !!  Specific Storage is 2 
          rZlith(i,3) = rLITHprop(ki,4)                                    !!  Vertical Anisotropy is 3 
        else
          rZlith(i,1) = rZE_KxSySsKv(ke,1)                                    !!  Hydraulic Conductivity is 1 
          rZlith(i,2) = rZE_KxSySsKv(ke,2+iOFF)                               !!  Specific Storage is 2 
          rZlith(i,3) = rZE_KxSySsKv(ke,4)                                    !!  Vertical Anisotropy is 3 
        endif
        rTHKminiSUM = rTHKminiSUM + rTHKmini
        rTlith = rTlith + rTHKmini*rZlith(i,1)
      end do    
c    Scale K of minimodel to T of regional model   
      rTregMOD = 0.0
      rTHKregSUM  = 0.0
      call iNODEreg(xFind,yFind, 0, ii, jj, 1)
c  Add rejection of sites outside of model domain  & reject if DTW > bottom of hole
      if( ii.ge.1 .and. jj.ge.1 .and. 
     +                 rZElith(nLZlith).gt.rZedge(1)) then 
        rZElith(1) = rZedge(1)
c  Process accumulation from regional model in first loop         
        do k = 1, NLAY
          rZElith(k+1) = rZElith(k) + rThk(ii,jj,k) 
          if(rZElith(k+1) .lt. rZedge(nzMini+1)) then 
            rTregMOD = rTregMOD + rTbar(ii,jj,k)
            rTHKregSUM  = rTHKregSUM + rThk(ii,jj,k)
          elseif( rZElith(k) .lt. rZedge(nzMini+1) ) then 
            rFrac = rZElith(k+1) - rZElith(k)
            rFrac =( rZedge(nzMini+1) - rZElith(k) )/rFrac
            rTregMOD = rTregMOD + rTbar(ii,jj,k)*rFrac
            rTHKregSUM  = rTHKregSUM + rThk(ii,jj,k)*rFrac 
          else
          endif  
        enddo
c  Transfer and extend mini model if needed               ----- DO NOT EXTEND, Force definition in logs  
        if( rZElith(NLAY+1) .gt. rZedge(nzMini+1) ) then 
          do k = 1, NLAY
            if( rZElith(k) .lt. rZedge(nzMini+1) ) then 
              kb = k
              rZedge(nzMini+k-kb+2) = rZElith(k+1)
              rZlith(nzMini+k-kb+1,1) = rTbar(ii,jj,k)/rThk(ii,jj,k)
              rZlith(nzMini+k-kb+1,2) = rLITHprop(1,3)
              if( k.lt.nlay ) then
                rVal = rKvKh(ii,jj,k)
              elseif( nlay.gt.1 ) then
                rVal = rKvKh(ii,jj,k-1)
              else
                rVal = rZlith(nzMini+k-kb,3)
              endif
              rZlith(nzMini+k-kb+1,3) = rVal
            endif  
          enddo
c    Extend minimodel to vertical extent of regional model, if Requested. 
c          if( trim(sZElith(nLZlith)) .ne. 'BASE' ) then 
c     +                       nzMini = nzMini + NLAY - kb + 1
        endif  
c   Report total thickness and T of minimodel and regional model
        write(ioEcho,'(a43,g12.4,a31,g12.4,a3)')
     +  '      Compared thickness of regional model ',rTHKregSUM,
     +  ' , L,      and mini model total ',rTHKminiSUM,', L'
        write(ioEcho,'(a43,g12.4,a31,g12.4,a6)')
     +  ' Compared transmissivity of regional model ',rTregMOD,
     +  ', L'//char(178)//'/T, and mini model as read',rTlith,
     +  ', L'//char(178)//'/T'
c        ----+----1----+----2----+----3----+----4----+----5----+----6
c      
c    Scale T/K to regional values
        if( bSCL )then
          rFrac = rTregMOD / rTlith
          do i = 1, nzMini
            rZlith(i,1) = rZlith(i,1) * rFrac
          end do    
        endif
c   Check that all Hyd Props are extended correctly
      else
        nzMini = 0  
        if(  rZElith(nLZlith).le.rZedge(1)) nzMini = -1
      endif    !!   End if block that checks well is in model domain
c
      return
      end
c ---------------------------------------------------------------------------------
      subroutine EchoFiles(ioIN,ioOUT, sDEL,sVAR, sSITE,  rQ,rDT,
     +         nZmini,rZedge,rZlith, iCOL,rRADedge, iBOUND1D,sSubDIR)
      include '..\T-COMP_SUBS-Common\T-COMP_Mini.inc'
      character*1  sDEL
      character*5  sVAR
      CHARACTER*64 sSubDIR
      CHARACTER*64 sNUM
      CHARACTER*64 sSITE
      CHARACTER*2048 sTxT
      CHARACTER*2048 sTxT2
      CHARACTER*2048 sPathFILE
      real rRADedge(nMAXminiR)
      real rZedge(nMAXminiZ)
      real rZlith(nMAXminiZ,3)
      real rB, rB1, rB2 
      real rQ 
      real rDT
      real rPI
      INTEGER iBOUND1D(nMAXminiNODE)
      INTEGER ierr
      INTEGER ioIN
      INTEGER ioOUT
      integer nZmini
      INTEGER iCOL
      INTEGER i
      INTEGER j
      INTEGER ki
      rPI = 3.141592654
c
      do while(0 .lt. 1 )
        read(ioIN,'(A)',end=10) sTxT
        sTxT2 = sTxT 
        call UPCASE(sTxT2)
        if( index(sTxT2,trim(sVAR)).gt.0 ) then
          if( index(sTxT2,trim(sVAR)//'ARRAY').gt.0 ) then
            call replace(sTxT,sVAR,' ',len(trim(sTxT)))
            ki =index(sTxT2,'ARRAY')
            sPathFILE = trim(sSubDIR) // sDEL // trim(sSITE) 
            sPathFILE = trim(sPathFILE) // sDEL // sTxT(ki:2048)
            ki =index(sPathFILE,' ')-1
            open(ioOUT+1,file=sPathFILE(1:ki))                 !!   OPEN External ARRAY file
            if( index(sTxT2,'1D.DELC').gt.0 ) then             !!    #ARRAY.1D.DELC.txt#
              write(ioOUT+1,'(500G14.6)')
     +             (rRADedge(i+1)-rRADedge(i),i=1,iCOL)
            elseif( index(sTxT2,'1D.DELR').gt.0 ) then         !!    #ARRAY.1D.DELR.txt#
              write(ioOUT+1,'(500G14.6)')
     +             (rZedge(i+1)-rZedge(i),i=1,nZmini)
            elseif( index(sTxT2,'2PIR').gt.0 ) then         !!    #ARRAY.2piR.txt#
              do j = 1,nZmini
                write(ioOUT+1,'(500G14.6)')
     +               ((rRADedge(i+1)+rRADedge(i))*rPI,i=1,iCOL)
              end do 
            elseif( index(sTxT2,'IBOUND').gt.0 ) then         !!    #ARRAY.IBOUND.txt#
              do j = iCOL , iCOL*nZmini, iCOL
               write(ioOUT+1,'(500(1x,I3.3))')(iBOUND1D(i),i=j-iCOL+1,j)
              end do 
            else                                               !!    Hydraulic properties 
              if( index(sTxT2,'ARRAY.HK').gt.0 ) then          !!    #ARRAY.HK__.txt#
                ki = 1                                                           !!  Hydraulic Conductivity is 1 
                rB = 1.0E10
              elseif( index(sTxT2,'ARRAY.SS').gt.0 ) then      !!    #ARRAY.Ss__.txt#
                ki = 2                                                           !!  Specific Storage is 2 
                rB = 1.0/( rZedge(nZmini+1) - rZedge(1) ) 
              else                                             !!    #ARRAY.HANI.txt#
                ki = 3                                                           !!  Vertical Anisotropy is 3 
                rB = 1.0
              endif  
              do j = 1,nZmini
                rB1 = rB*iBOUND1D((j-1)*iCOL+1)
                if( j.eq.nZmini .and. rB.gt.2.0 ) rB1 = 1.0E-8 
                if( j.eq.nZmini .and. rB.lt.0.99) rB1 = 0.0000 
                rB2 = rB*iBOUND1D((j-1)*iCOL+2)
                write(ioOUT+1,'(500G14.6)')rB1, rB2,
     +                         (rZlith(j,ki),i=3,iCOL)
              end do 
            endif
            close(ioOUT+1)                               !!   CLOSE External ARRAY file
          elseif( index(sTxT2,trim(sVAR)//'ROW').gt.0 ) then
            write(sNUM,'(i5.5)') nZmini
            call sSUBstring(sTxT,sNUM, sVAR, sTxT)        !!  Substitute  correct ROW numbers of Mini-Model
            write(sNUM,'(i5.5)') iCOL
            call sSUBstring(sTxT,sNUM, sVAR, sTxT)        !!  Substitute  correct COLUMN numbers of Mini-Model
          elseif( index(sTxT2,trim(sVAR)//'DELTIME').gt.0 ) then
            write(sNUM,'(E9.3)') rDT
            call sSUBstring(sTxT,sNUM, sVAR, sTxT)        !!  Substitute  Stress period duration of Mini-Model
          elseif( index(sTxT2,trim(sVAR)//'Q-FT3/T').gt.0 ) then
            write(sNUM,'(E9.3)') rQ
            call sSUBstring(sTxT,sNUM, sVAR, sTxT)        !!  Substitute  pumping rate of Mini-Model
          elseif( index(sTxT2,trim(sVAR)//'COLBOT').gt.0 ) then
            write(sNUM,'(I8.8)') nZmini
            call sSUBstring(sTxT,sNUM, sVAR, sTxT)        !!  Substitute  Lowest node in MNW pair of Mini-Model
          elseif( index(sTxT2,trim(sVAR)//'_SITE_').gt.0 ) then
            call sSUBstring(sTxT,sSite, sVAR, sTxT)        !!  Substitute  Name of site in Model Viewer file
          else
          endif
        endif
        write(ioOUT,'(A)') trim(sTxT)//'  '
      end do  
c
   10 return
      end      
c ---------------------------------------------------------------------------------
      subroutine RminiDEFINE(iCOL,rRADwel, rRADann, rRADext, rRADedge)
      include '..\T-COMP_SUBS-Common\T-COMP_Mini.inc'
      real rRADedge(nMAXminiR)
      real rRADwel
      real rRADann
      real rRADext
      real rMULT
      real rWIDE
      INTEGER iCOL
c
      rRADedge(1) = 0.000
      rRADedge(2) = rRADwel
      rWIDE = rRADann - rRADwel
      rMULT = rFRCmlt(rWIDE, rRADext, iCOL-1) 
      do i = 3, iCOL+1
              rRADedge(i) = rRADedge(i-1) + rWIDE
        rWIDE = rWIDE*rMULT
      end do      
c
      return
      end      
c ---------------------------------------------------------------------------------
      subroutine IBminiDEFINE(iCOL, nZmini,rZedge, sSITE, nWells,
     +                        sWelNAME,nWelINT,rWelINT, iBOUND1D)
      include '..\T-COMP_SUBS-Common\T-COMP_Mini.inc'
      CHARACTER*64 sWelNAME(nMAXwell)
      CHARACTER*64 sSITE
      real rZedge(nMAXminiZ)
      real rWelINT(nMAXint)
      real rTB(nMAXminiZ)
      real rZcenter
      INTEGER iBOUND1D(nMAXminiNODE)
      INTEGER nWelINT(nMAXwell)
      INTEGER nWells
      integer nZmini
      INTEGER iCOL
      INTEGER iWEL
      INTEGER i
      INTEGER j
      INTEGER ke
c
      iWEL = iMatchs(sSITE, sWelNAME, nWells)
      nTB  = nWelINT(iWEL+1) - nWelINT(iWEL)
      iWEL = nWelINT(iWEL) 
      do i = 1, nTB
        rTB(i) = rWelINT(i+iWEL)
      end do
c      
      do j = 1,nZmini
        rZcenter = (rZedge(j+1)+rZedge(j))/2.
        iBOUND1D((j-1)*iCOL+1) = 1
        if( rZcenter.gt.rTB(nTB) ) iBOUND1D((j-1)*iCOL+1) = 0  
        ke = iMATCHr(rZcenter, rTB, nTB, 1)
        iBOUND1D((j-1)*iCOL+2) = mod(ke,2)
        do i = 3,iCOL
          iBOUND1D((j-1)*iCOL+i) = 1
        end do 
      end do 
c
      return
      end      
        